# Interface AstNode

#### Hierarchy

- AstNode

- Defined in codec/lib/ast/types.ts:8

#####
Index

### Properties

anonymous?
ast_type?
baseType?
canonicalName?
constant?
contractKind?
expression?
hexValue?
id
indexed?
isConstructor?
keyType?
kind?
linearizedBaseContracts?
members?
mutability?
name
nodeType
nodes?
parameterTypes?
parameters?
payable?
referencedDeclaration?
returnParameterTypes?
returnParameters?
scope?
src
stateMutability?
stateVariable?
storageLocation?
typeDescriptions
typeName?
underlyingType?
usedErrors?
value?
valueType?
visibility?

## Properties

### `Optional` anonymous

anonymous?: boolean

- Defined in codec/lib/ast/types.ts:54

### `Optional` ast_type

ast_type?: string

- Defined in codec/lib/ast/types.ts:19

### `Optional` baseType

baseType?: AstNode

- Defined in codec/lib/ast/types.ts:49

### `Optional` canonicalName

canonicalName?: string

- Defined in codec/lib/ast/types.ts:13

### `Optional` constant

constant?: boolean

- Defined in codec/lib/ast/types.ts:9

### `Optional` contractKind

contractKind?: ContractKind

- Defined in codec/lib/ast/types.ts:55

### `Optional` expression

expression?: {
referencedDeclaration?: any;
}

#### Type declaration

- ##### `Optional` referencedDeclaration?: any

- Defined in codec/lib/ast/types.ts:26

### `Optional` hexValue

hexValue?: string

- Defined in codec/lib/ast/types.ts:35

### id

id: number

- Defined in codec/lib/ast/types.ts:11

### `Optional` indexed

indexed?: boolean

- Defined in codec/lib/ast/types.ts:53

### `Optional` isConstructor

isConstructor?: boolean

- Defined in codec/lib/ast/types.ts:56

### `Optional` keyType

keyType?: AstNode

- Defined in codec/lib/ast/types.ts:50

### `Optional` kind

kind?: string

- Defined in codec/lib/ast/types.ts:34

### `Optional` linearizedBaseContracts

linearizedBaseContracts?: number[]

- Defined in codec/lib/ast/types.ts:14

### `Optional` members

members?: AstNode[]

- Defined in codec/lib/ast/types.ts:15

### `Optional` mutability

mutability?: "mutable" | "immutable" | "constant"

- Defined in codec/lib/ast/types.ts:10

### name

name: string

- Defined in codec/lib/ast/types.ts:12

### nodeType

nodeType: string

- Defined in codec/lib/ast/types.ts:18

### `Optional` nodes

nodes?: AstNode[]

- Defined in codec/lib/ast/types.ts:17

### `Optional` parameterTypes

parameterTypes?: {
parameters: AstNode[];
}

#### Type declaration

- ##### parameters: AstNode[]

- Defined in codec/lib/ast/types.ts:43

### `Optional` parameters

parameters?: {
parameters: AstNode[];
}

#### Type declaration

- ##### parameters: AstNode[]

- Defined in codec/lib/ast/types.ts:37

### `Optional` payable

payable?: boolean

- Defined in codec/lib/ast/types.ts:52

### `Optional` referencedDeclaration

referencedDeclaration?: any

- Defined in codec/lib/ast/types.ts:36

### `Optional` returnParameterTypes

returnParameterTypes?: {
parameters: AstNode[];
}

#### Type declaration

- ##### parameters: AstNode[]

- Defined in codec/lib/ast/types.ts:46

### `Optional` returnParameters

returnParameters?: {
parameters: AstNode[];
}

#### Type declaration

- ##### parameters: AstNode[]

- Defined in codec/lib/ast/types.ts:40

### `Optional` scope

scope?: number

- Defined in codec/lib/ast/types.ts:20

### src

src: string

- Defined in codec/lib/ast/types.ts:21

### `Optional` stateMutability

stateMutability?: Mutability

- Defined in codec/lib/ast/types.ts:33

### `Optional` stateVariable

stateVariable?: boolean

- Defined in codec/lib/ast/types.ts:22

### `Optional` storageLocation

storageLocation?: string

- Defined in codec/lib/ast/types.ts:23

### typeDescriptions

typeDescriptions: TypeDescriptions

- Defined in codec/lib/ast/types.ts:24

### `Optional` typeName

typeName?: AstNode

- Defined in codec/lib/ast/types.ts:25

### `Optional` underlyingType

underlyingType?: AstNode

- Defined in codec/lib/ast/types.ts:16

### `Optional` usedErrors

usedErrors?: number[]

- Defined in codec/lib/ast/types.ts:57

### `Optional` value

value?: any

- Defined in codec/lib/ast/types.ts:29

### `Optional` valueType

valueType?: AstNode

- Defined in codec/lib/ast/types.ts:51

### `Optional` visibility

visibility?: string

- Defined in codec/lib/ast/types.ts:30

Generated using TypeDoc